# Ogre::ImageCodec Class Reference

Codec specialized in images. More...

`#include <OgreImageCodec.h>`

Inheritance diagram for Ogre::ImageCodec:

List of all members.

## Public Types

typedef SharedPtr< CodecData > | CodecDataPtr
typedef std::pair< MemoryDataStreamPtr, CodecDataPtr > | DecodeResult
| Result of a decoding; both a decoded data stream and CodecData metadata.

## Public Member Functions

virtual | ~ImageCodec ()
virtual DataStreamPtr | code (MemoryDataStreamPtr &input, CodecDataPtr &pData) const=0
| Codes the data in the input stream and saves the result in the output stream.
virtual void | codeToFile (MemoryDataStreamPtr &input, const String &outFileName, CodecDataPtr &pData) const=0
| Codes the data in the input chunk and saves the result in the output filename provided.
virtual DecodeResult | decode (DataStreamPtr &input) const=0
| Codes the data from the input chunk into the output chunk.
virtual String | getType () const=0
| Returns the type of the codec as a String.

## Static Public Member Functions

void | registerCodec (Codec *pCodec)
| Registers a new codec in the database.
void | unRegisterCodec (Codec *pCodec)
| Unregisters a codec from the database.
Codec * | getCodec (const String &extension)
| Gets the codec registered for the passed in file extension.

## Protected Types

typedef std::map< String, Codec * > | CodecList

## Static Protected Attributes

CodecList | ms_mapCodecs
| A map that contains all the registered codecs.

## Detailed Description

Codec specialized in images.

Remarks:
  The users implementing subclasses of ImageCodec are required to return a valid pointer to a ImageData class from the decode(...) function.

Definition at line 38 of file OgreImageCodec.h.

## Member Typedef Documentation

typedef SharedPtr<CodecData> Ogre::Codec::CodecDataPtr `[inherited]`

| Definition at line 61 of file OgreCodec.h.

typedef std::map< String, Codec* > Ogre::Codec::CodecList `[protected, inherited]`

| Definition at line 46 of file OgreCodec.h.

typedef std::pair<MemoryDataStreamPtr, CodecDataPtr> Ogre::Codec::DecodeResult `[inherited]`

| Result of a decoding; both a decoded data stream and CodecData metadata. Definition at line 97 of file OgreCodec.h.

## Constructor & Destructor Documentation

virtual Ogre::ImageCodec::~ImageCodec | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual DataStreamPtr Ogre::Codec::code | ( | MemoryDataStreamPtr & | input,
|  | CodecDataPtr & | pData
| ) | const`[pure virtual, inherited]`

| Codes the data in the input stream and saves the result in the output stream. Implemented in Ogre::ILImageCodec, and Ogre::EXRCodec.

virtual void Ogre::Codec::codeToFile | ( | MemoryDataStreamPtr & | input,
|  | const String & | outFileName,
|  | CodecDataPtr & | pData
| ) | const`[pure virtual, inherited]`

Codes the data in the input chunk and saves the result in the output filename provided.

Provided for efficiency since coding to memory is progressive therefore memory required is unknown leading to reallocations.

Parameters:

  input | The input data
  outFileName | The filename to write to
  pData | Extra information to be passed to the codec (codec type specific)

Implemented in Ogre::ILImageCodec, and Ogre::EXRCodec.

virtual DecodeResult Ogre::Codec::decode | ( | DataStreamPtr & | input | ) | const`[pure virtual, inherited]`

Codes the data from the input chunk into the output chunk.

Parameters:

  input | Stream containing the encoded data

Note:
  Has a variable number of arguments, which depend on the codec type.

Implemented in Ogre::ILImageCodec, and Ogre::EXRCodec.

Codec* Ogre::Codec::getCodec | ( | const String & | extension | ) | `[static, inherited]`

| Gets the codec registered for the passed in file extension.

virtual String Ogre::Codec::getType | ( |  | ) | const`[pure virtual, inherited]`

| Returns the type of the codec as a String. Implemented in Ogre::ILImageCodec, and Ogre::EXRCodec. Referenced by Ogre::Codec::registerCodec(), and Ogre::Codec::unRegisterCodec().

void Ogre::Codec::registerCodec | ( | Codec * | pCodec | ) | `[static, inherited]`

| Registers a new codec in the database. Definition at line 68 of file OgreCodec.h. References Ogre::Codec::getType().

void Ogre::Codec::unRegisterCodec | ( | Codec * | pCodec | ) | `[static, inherited]`

| Unregisters a codec from the database. Definition at line 75 of file OgreCodec.h. References Ogre::Codec::getType().

## Member Data Documentation

CodecList Ogre::Codec::ms_mapCodecs `[static, protected, inherited]`

| A map that contains all the registered codecs. Definition at line 49 of file OgreCodec.h.

The documentation for this class was generated from the following file:

- OgreImageCodec.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Feb 12 13:00:49 2006